// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineregisterprotocolhandlerrequest_wrapper.h"

// Argument includes
#include <QString>
#include <QtWebEngineCore/qwebengineregisterprotocolhandlerrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineRegisterProtocolHandlerRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >()))
        return -1;

    ::QWebEngineRegisterProtocolHandlerRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineRegisterProtocolHandlerRequest", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineRegisterProtocolHandlerRequest::QWebEngineRegisterProtocolHandlerRequest()
    // 1: QWebEngineRegisterProtocolHandlerRequest::QWebEngineRegisterProtocolHandlerRequest(QWebEngineRegisterProtocolHandlerRequest)
    if (numArgs == 0) {
        overloadId = 0; // QWebEngineRegisterProtocolHandlerRequest()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QWebEngineRegisterProtocolHandlerRequest(QWebEngineRegisterProtocolHandlerRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QWebEngineRegisterProtocolHandlerRequest()
        {

            // QWebEngineRegisterProtocolHandlerRequest()
            cptr = new ::QWebEngineRegisterProtocolHandlerRequest();
            break;
        }
        case 1: // QWebEngineRegisterProtocolHandlerRequest(const QWebEngineRegisterProtocolHandlerRequest &QWebEngineRegisterProtocolHandlerRequest)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
            ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebEngineRegisterProtocolHandlerRequest(QWebEngineRegisterProtocolHandlerRequest)
                cptr = new ::QWebEngineRegisterProtocolHandlerRequest(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // accept()
        cppSelf->accept();
    }

     return Sbk_ReturnFromPython_None();
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // origin()const
        QUrl cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->origin();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // reject()
        cppSelf->reject();
    }

     return Sbk_ReturnFromPython_None();
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // scheme()const
        QString cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->scheme();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings[] = {
    "origin:",
    "scheme:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineRegisterProtocolHandlerRequest_methods[] = {
    {"accept", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept), METH_NOARGS, nullptr},
    {"origin", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin), METH_NOARGS, nullptr},
    {"reject", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject), METH_NOARGS, nullptr},
    {"scheme", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator!=(const QWebEngineRegisterProtocolHandlerRequest &that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator==(const QWebEngineRegisterProtocolHandlerRequest &that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineRegisterProtocolHandlerRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(void)
{
    return _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type;
}

static PyType_Slot Sbk_QWebEngineRegisterProtocolHandlerRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineRegisterProtocolHandlerRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineRegisterProtocolHandlerRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), new ::QWebEngineRegisterProtocolHandlerRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineRegisterProtocolHandlerRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineRegisterProtocolHandlerRequest_SignatureStrings[] = {
    "1:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest(self,*:KeywordOnly=None,origin:QUrl=None,scheme:QString=None)",
    "0:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest(self,QWebEngineRegisterProtocolHandlerRequest:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest,*:KeywordOnly=None,origin:QUrl=None,scheme:QString=None)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.accept(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.origin(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.reject(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.scheme(self)->QString",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__copy__(self)->typing.Self",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__ne__(self,that:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest)->bool",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__eq__(self,that:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineRegisterProtocolHandlerRequest_SignatureByteSize = 213;
static constexpr uint8_t QWebEngineRegisterProtocolHandlerRequest_SignatureBytes[213] = {
    0x78, 0xda, 0xb5, 0x92, 0x4d, 0x8b, 0xc2, 0x30, 0x10, 0x86, 0xef, 0xfe, 0x12, 0x5d, 0x6a, 0xd9,
    0xbd, 0xec, 0xa1, 0xa0, 0x17, 0x11, 0x84, 0x05, 0xb5, 0x96, 0xc5, 0x63, 0xa9, 0xe9, 0x6b, 0x1b,
    0x89, 0x99, 0x3a, 0xcd, 0x22, 0xf9, 0xf7, 0x1b, 0x8c, 0x1f, 0x57, 0x31, 0xf1, 0x38, 0x43, 0xe6,
    0x99, 0xe7, 0x1d, 0xf2, 0x95, 0xad, 0x6d, 0x21, 0x6b, 0x7c, 0xa7, 0xb9, 0xd9, 0x62, 0x37, 0xd7,
    0x8d, 0xd4, 0x98, 0x11, 0x23, 0xcd, 0xef, 0xe5, 0x06, 0x8d, 0xec, 0x0d, 0x78, 0xcd, 0x64, 0x48,
    0x90, 0x5a, 0x54, 0xba, 0x56, 0xe0, 0x0d, 0x4e, 0x7f, 0xe8, 0xcd, 0xb0, 0x87, 0xda, 0x27, 0x1f,
    0xd9, 0x0f, 0xec, 0x99, 0xb8, 0x5e, 0x69, 0x65, 0x27, 0x4b, 0xd2, 0x48, 0x88, 0xa5, 0x9b, 0xce,
    0xf2, 0x5f, 0x56, 0xbe, 0xd1, 0x8b, 0x16, 0x47, 0x64, 0x79, 0x61, 0x58, 0xea, 0xe6, 0xd2, 0x1b,
    0x0d, 0x3e, 0x23, 0x09, 0x3c, 0xfb, 0x3a, 0x78, 0xdd, 0xeb, 0x51, 0x43, 0x37, 0xa7, 0x95, 0x10,
    0xe8, 0x7c, 0xde, 0x08, 0x34, 0x2f, 0xed, 0x69, 0xe3, 0xe9, 0x03, 0xe7, 0x29, 0x2e, 0x4a, 0xf8,
    0x0a, 0xc6, 0x01, 0x22, 0x9a, 0xb0, 0x3f, 0xea, 0x4d, 0xf8, 0x7a, 0xdb, 0x70, 0x6c, 0x59, 0x0a,
    0xea, 0x6c, 0x59, 0xde, 0xc0, 0xc6, 0x76, 0x8e, 0x9b, 0x16, 0xae, 0x8a, 0x01, 0xd7, 0xb8, 0xa2,
    0x13, 0xd3, 0x56, 0xe1, 0xdf, 0xcf, 0x09, 0xee, 0x88, 0x54, 0x0c, 0x33, 0x9c, 0xde, 0x62, 0xf6,
    0x0f, 0xa8, 0x3e, 0x9e, 0xcb
};
#endif

PyTypeObject *init_QWebEngineRegisterProtocolHandlerRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineRegisterProtocolHandlerRequest",
        "QWebEngineRegisterProtocolHandlerRequest",
        &Sbk_QWebEngineRegisterProtocolHandlerRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineRegisterProtocolHandlerRequest >,
        Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(); // references _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineRegisterProtocolHandlerRequest_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineRegisterProtocolHandlerRequest_SignatureBytes, QWebEngineRegisterProtocolHandlerRequest_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible,
        QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest,
        QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineRegisterProtocolHandlerRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineRegisterProtocolHandlerRequest >("QWebEngineRegisterProtocolHandlerRequest");

    return pyType;
}
