// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWEBENGINEURLSCHEMEHANDLERWRAPPER_H
#define SBK_QWEBENGINEURLSCHEMEHANDLERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebEngineCore/qwebengineurlschemehandler.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QWebEngineUrlSchemeHandlerWrapper : public QWebEngineUrlSchemeHandler
{
public:
    QWebEngineUrlSchemeHandlerWrapper(::QObject * parent = nullptr);
    QWebEngineUrlSchemeHandlerWrapper(const QWebEngineUrlSchemeHandlerWrapper &) = delete;
    QWebEngineUrlSchemeHandlerWrapper& operator=(const QWebEngineUrlSchemeHandlerWrapper &) = delete;
    QWebEngineUrlSchemeHandlerWrapper(QWebEngineUrlSchemeHandlerWrapper &&) = delete;
    QWebEngineUrlSchemeHandlerWrapper& operator=(QWebEngineUrlSchemeHandlerWrapper &&) = delete;
    ~QWebEngineUrlSchemeHandlerWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void requestStarted(::QWebEngineUrlRequestJob * arg__1) override;
    static void sbk_o_requestStarted(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWebEngineUrlRequestJob * arg__1);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QWEBENGINEURLSCHEMEHANDLERWRAPPER_H
