// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginequick_python.h"

// main header
#include "qquickwebenginedownloadrequest_wrapper.h"

// Wrappers providing overrides
#include "qquickwebengineprofile_wrapper.h"

// Argument includes
#include <qcoreevent.h>
#include <qmetaobject.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

// Native ---------------------------------------------------------

void QQuickWebEngineDownloadRequestWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

void QQuickWebEngineDownloadRequestWrapper::childEvent(::QChildEvent * event)
{
    static const char *funcName = "childEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[0], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::childEvent(event);
    }
    QQuickWebEngineProfileWrapper::sbk_o_childEvent("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, event);
}

void QQuickWebEngineDownloadRequestWrapper::connectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "connectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[1], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::connectNotify(signal);
    }
    QQuickWebEngineProfileWrapper::sbk_o_connectNotify("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, signal);
}

void QQuickWebEngineDownloadRequestWrapper::customEvent(::QEvent * event)
{
    static const char *funcName = "customEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[2], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::customEvent(event);
    }
    QQuickWebEngineProfileWrapper::sbk_o_customEvent("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, event);
}

void QQuickWebEngineDownloadRequestWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "disconnectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[3], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::disconnectNotify(signal);
    }
    QQuickWebEngineProfileWrapper::sbk_o_connectNotify("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, signal);
}

bool QQuickWebEngineDownloadRequestWrapper::event(::QEvent * event)
{
    static const char *funcName = "event";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[4], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::event(event);
    }
    return QQuickWebEngineProfileWrapper::sbk_o_event("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, event);
}

bool QQuickWebEngineDownloadRequestWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    static const char *funcName = "eventFilter";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[5], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::eventFilter(watched, event);
    }
    return QQuickWebEngineProfileWrapper::sbk_o_eventFilter("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, watched, event);
}

void QQuickWebEngineDownloadRequestWrapper::timerEvent(::QTimerEvent * event)
{
    static const char *funcName = "timerEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, gil, funcName, &m_PyMethodCache[6], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::timerEvent(event);
    }
    QQuickWebEngineProfileWrapper::sbk_o_timerEvent("QQuickWebEngineDownloadRequest", funcName, gil, pyOverride, event);
}

const QMetaObject *QQuickWebEngineDownloadRequestWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return QQuickWebEngineDownloadRequest::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int QQuickWebEngineDownloadRequestWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = QQuickWebEngineDownloadRequest::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *QQuickWebEngineDownloadRequestWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf != nullptr && PySide::inherits(Py_TYPE(pySelf), _clname))
        return static_cast<void *>(const_cast< QQuickWebEngineDownloadRequestWrapper *>(this));
    return QQuickWebEngineDownloadRequest::qt_metacast(_clname);
}

QQuickWebEngineDownloadRequestWrapper::~QQuickWebEngineDownloadRequestWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int Sbk_QQuickWebEngineDownloadRequest_Init(PyObject *, PyObject *, PyObject *)
{
    Shiboken::Errors::setInstantiateNonConstructible("QQuickWebEngineDownloadRequest");
    return -1;
}

static PyObject *Sbk_QQuickWebEngineDownloadRequestFunc_qt_qmlMarker_uncreatable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuickWebEngineDownloadRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QQuickWebEngineDownloadRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // qt_qmlMarker_uncreatable()
        cppSelf->qt_qmlMarker_uncreatable();
    }

     return Sbk_ReturnFromPython_None();
}


static const char *Sbk_QQuickWebEngineDownloadRequest_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuickWebEngineDownloadRequest_methods[] = {
    {"qt_qmlMarker_uncreatable", reinterpret_cast<PyCFunction>(Sbk_QQuickWebEngineDownloadRequestFunc_qt_qmlMarker_uncreatable), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QQuickWebEngineDownloadRequest_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::QQuickWebEngineDownloadRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QQuickWebEngineDownloadRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<QQuickWebEngineDownloadRequestWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QQuickWebEngineDownloadRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuickWebEngineDownloadRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuickWebEngineDownloadRequest_Type = nullptr;
static PyTypeObject *Sbk_QQuickWebEngineDownloadRequest_TypeF(void)
{
    return _Sbk_QQuickWebEngineDownloadRequest_Type;
}

static PyType_Slot Sbk_QQuickWebEngineDownloadRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QQuickWebEngineDownloadRequest_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuickWebEngineDownloadRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuickWebEngineDownloadRequest_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuickWebEngineDownloadRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuickWebEngineDownloadRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuickWebEngineDownloadRequest_spec = {
    "2:PySide6.QtWebEngineQuick.QQuickWebEngineDownloadRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuickWebEngineDownloadRequest_slots
};

} //extern "C"

static void *Sbk_QQuickWebEngineDownloadRequest_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::QQuickWebEngineDownloadRequest *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQuickWebEngineDownloadRequest_PythonToCpp_QQuickWebEngineDownloadRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuickWebEngineDownloadRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQuickWebEngineDownloadRequest_PythonToCpp_QQuickWebEngineDownloadRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQuickWebEngineDownloadRequest_TypeF()))
        return QQuickWebEngineDownloadRequest_PythonToCpp_QQuickWebEngineDownloadRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQuickWebEngineDownloadRequest_PTR_CppToPython_QQuickWebEngineDownloadRequest(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::QQuickWebEngineDownloadRequest *>(const_cast<void *>(cppIn)), Sbk_QQuickWebEngineDownloadRequest_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QQuickWebEngineDownloadRequest_SignatureStrings[] = {
    "PySide6.QtWebEngineQuick.QQuickWebEngineDownloadRequest.qt_qmlMarker_uncreatable(self)",
    nullptr}; // Sentinel
#else
static constexpr size_t QQuickWebEngineDownloadRequest_SignatureByteSize = 84;
static constexpr uint8_t QQuickWebEngineDownloadRequest_SignatureBytes[84] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x4f, 0x4d, 0x72,
    0xcd, 0x4b, 0xcf, 0xcc, 0x4b, 0x0d, 0x2c, 0xcd, 0x4c, 0xce, 0xd6, 0x0b, 0x04, 0x53, 0x70, 0x41,
    0x97, 0xfc, 0xf2, 0xbc, 0x9c, 0xfc, 0xc4, 0x94, 0xa0, 0xd4, 0xc2, 0xd2, 0xd4, 0xe2, 0x12, 0xbd,
    0xc2, 0x92, 0xf8, 0xc2, 0xdc, 0x1c, 0xdf, 0xc4, 0xa2, 0xec, 0xd4, 0xa2, 0xf8, 0xd2, 0xbc, 0xe4,
    0xa2, 0xd4, 0xc4, 0x92, 0xc4, 0xa4, 0x9c, 0x54, 0x8d, 0xe2, 0xd4, 0x9c, 0x34, 0x4d, 0x2e, 0x00,
    0xa8, 0x18, 0x21, 0x02
};
#endif

PyTypeObject *init_QQuickWebEngineDownloadRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QQuickWebEngineDownloadRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QQuickWebEngineDownloadRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QQuickWebEngineDownloadRequest_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDownloadRequest_IDX]))));

    _Sbk_QQuickWebEngineDownloadRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQuickWebEngineDownloadRequest",
        "QQuickWebEngineDownloadRequest*",
        &Sbk_QQuickWebEngineDownloadRequest_spec,
        &Shiboken::callCppDestructor< QQuickWebEngineDownloadRequest >,
        Sbk_QQuickWebEngineDownloadRequest_Type_bases.object(),
        0);
    auto *pyType = Sbk_QQuickWebEngineDownloadRequest_TypeF(); // references _Sbk_QQuickWebEngineDownloadRequest_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QQuickWebEngineDownloadRequest_SignatureStrings);
#else
    InitSignatureBytes(pyType, QQuickWebEngineDownloadRequest_SignatureBytes, QQuickWebEngineDownloadRequest_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuickWebEngineDownloadRequest_PropertyStrings);
    SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QQuickWebEngineDownloadRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQuickWebEngineDownloadRequest_PythonToCpp_QQuickWebEngineDownloadRequest_PTR,
        is_QQuickWebEngineDownloadRequest_PythonToCpp_QQuickWebEngineDownloadRequest_PTR_Convertible,
        QQuickWebEngineDownloadRequest_PTR_CppToPython_QQuickWebEngineDownloadRequest);

    Shiboken::Conversions::registerConverterName(converter, "QQuickWebEngineDownloadRequest");
    Shiboken::Conversions::registerConverterName(converter, "QQuickWebEngineDownloadRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QQuickWebEngineDownloadRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuickWebEngineDownloadRequest).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(QQuickWebEngineDownloadRequestWrapper).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QQuickWebEngineDownloadRequest_TypeF(), &Sbk_QQuickWebEngineDownloadRequest_typeDiscovery);

    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::QQuickWebEngineDownloadRequest::staticMetaObject, sizeof(QQuickWebEngineDownloadRequestWrapper));

    return pyType;
}
